unit uf_TMEdemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Spin, Sockets, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdAntiFreezeBase, IdAntiFreeze;

type
  TfTMETeplomer = class(TForm)
    GroupBox1: TGroupBox;
    txtIP: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    sePort: TSpinEdit;
    cmdConnect: TButton;
    pnlTeplota: TPanel;
    Timer1: TTimer;
    IdTCPClient1: TIdTCPClient;
    Image1: TImage;
    Image2: TImage;
    procedure sePortChange(Sender: TObject);
    procedure txtIPChange(Sender: TObject);
    procedure cmdConnectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  PSpinelHeader = ^TSpinelHeader;
  TSpinelHeader = record    //struktura znzorujc hlaviku spinel protokolu
    Prefix:char;   //prefix je vdy "*"
    Format:char;   //formt pouivajc TME je "B" (66)
    ADR:char;      //adresa zazen (u TME se ignoruje)
    ACK:char;      //potvrzen (kd instrukce) (u TME je to "E" - automaticky vyslan instrukce)
  end;

var
  fTMETeplomer: TfTMETeplomer;
  CurrentLNG:string;

implementation

uses Math, uLanguage;

{$R *.dfm}

procedure TfTMETeplomer.sePortChange(Sender: TObject);
begin
 IdTCPClient1.Port := sePort.Value; //prava portu
end;

procedure TfTMETeplomer.txtIPChange(Sender: TObject);
begin
 IdTCPClient1.Host := txtIP.Text; //prava ip adresy
end;

procedure TfTMETeplomer.cmdConnectClick(Sender: TObject);
begin
  try
    Screen.Cursor := crHourGlass;
    //oteven i zaven TCP spojen
    if IdTCPClient1.Connected then IdTCPClient1.Disconnect else IdTCPClient1.Connect(2500);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfTMETeplomer.FormClose(Sender: TObject;
  var Action: TCloseAction);
var ifi:textfile;
begin
  //Zaven TCP spojen pokud je jet oteveno pi ukonen programu
  if IdTCPClient1.Connected then IdTCPClient1.Disconnect;

  try
   AssignFile(ifi,ExtractFileDir(Application.ExeName)+'\lng.ini');
   Rewrite(ifi);
   WriteLn(ifi,'[LNG]='+CurrentLNG);
   Closefile(ifi);
  Except
    MessageDlg('Can''''t save LNG file.', mtError,[mbOk], 0);
  End;
end;

procedure TfTMETeplomer.Timer1Timer(Sender: TObject);
var Buf:string;
    Text:string;
    SpinelHeader:PSpinelHeader;
    start,cr,tep:integer;
begin
  try
    Buf:=IdTCPClient1.CurrentReadBuffer; //naplnn buferu datama
    if (length(Buf)>0) then  //pokud je buffer naplnn
    begin
      start := pos('*',Buf); //hledn prefixu spinel paketu
      if (start>0)and(length(Buf)>start+4) then //pokud byl nalezen prefix a zbvajc dkla je alespo 4 (minimum pro platn spinel paket)
      begin
        Buf:=copy(Buf,start,length(Buf)-start+1); //oznut od ppadnch neplatnch pedchzejcch dat
        SpinelHeader:=@Buf[1];
        if (SpinelHeader.Prefix = '*') //sprvn prefix
           and (SpinelHeader.Format = 'B') //sprvn formt
           and (pos(#13,Buf)>0)  //sprvn zakonen
        then
        begin
          cr:=pos(#13,Buf); //nalezen konce dat
          Text:=copy(Buf,5,cr-5); //zjskn dat ze spinel paketu
          tep:=pos('+',Text);  //Vyhledn zatku teploty v datech (vdy zan + nebo -)
          if tep=0 then tep:=pos('-',Text);
          Text:=copy(Text,tep,length(Text)-tep+1);//Zjskn samotn teploty z dat
          Text:=Text+' C'; //pidn jednotky - stup celsia
          pnlTeplota.Caption := Text; //zobrazen teploty na panelu
          If Text<>'' then Application.Title:='TME Demo   '+pnlTeplota.Caption
             else Application.Title:='TME Demo';
        end
        else pnlTeplota.Caption := '-'; //pokud je neplatn spinel paket, zobraz se naplatn data pomlkou
      end;
    end;
  except
  end;
end;

procedure TfTMETeplomer.IdTCPClient1Connected(Sender: TObject);
begin
  //nastaven komponent po oteven TCP spojen
  txtIP.Enabled := false;
  sePort.Enabled := false;
cmdConnect.Caption := Language.text('Odpojit','Odpojit');
  timer1.Enabled := true;
  Timer1Timer(Timer1);
end;

procedure TfTMETeplomer.IdTCPClient1Disconnected(Sender: TObject);
begin
  //nastaven komponent po zaven TCP spojen
  txtIP.Enabled := true;
  sePort.Enabled := true;
  pnlTeplota.Caption := '';
  cmdConnect.Caption := Language.text('Pipojit','Pipojit');
  Timer1.Enabled := false;
end;

procedure TfTMETeplomer.Image1Click(Sender: TObject);
begin
  CurrentLNG:='cesky.lng.xml';
  Language.LoadLngFile(CurrentLNG);
end;

procedure TfTMETeplomer.Image2Click(Sender: TObject);
begin
  CurrentLNG:='english.lng.xml';
  Language.LoadLngFile(CurrentLNG);
end;

procedure TfTMETeplomer.FormCreate(Sender: TObject);
var ifi:textfile;
    tempS:string;
begin
  If FileExists((ExtractFileDir(Application.ExeName)+'\lng.ini')) then
    begin
     try
      AssignFile(ifi,ExtractFileDir(Application.ExeName)+'\lng.ini');
      Reset(ifi);
      ReadLn(ifi,tempS);
      CurrentLNG:=Copy(TempS,7,Length(tempS));
      Closefile(ifi);
     Except
       CurrentLNG:='cesky.lng.xml';
     End;
    End
   else CurrentLNG:='cesky.lng.xml';
  Language.LoadLngFile(CurrentLNG);
end;

end.
